#include <stdio.h>
#include <cstdio>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <signal.h>
#include <iostream>
#include <string.h>

#define INF 999999999999.0                                                      
#include "libsub.h"


void takeNsave(int pNo)
{
    FILE *fsave,*fdesc;
    long long i = 0 , j = 0 , k = 0;
    double *ts;
    long long p;
    char tmp[5];
    int lind = 0,  rind = 0;



    /*char fname[100]= "temp\\p_";*/
    char fname[100]= "temp/p_";
    /* strcat(fname,itoa(pNo,tmp,10)); */
    std::sprintf(tmp, "%d", pNo);
    strcat(fname,tmp);
    fsave = fopen(fname,"wb");

    i = 0;
    while ( i < pS1 )
    {
        fwrite(data1[ind1[i]],sizeof(double),LENGTH,fsave);
        p = ind1[i]+pageBoundaries[pNo-1];
        locsP[i] = p;
        i++;
    }
    
    st[pNo] = Dist1[iRef][ind1[0]];
    en[pNo] = Dist1[iRef][ind1[pS1-1]];

    fclose(fsave);

    /*char dname[100] = "temp\\p_desc_";*/
    char dname[100] = "temp/p_desc_";
    /*strcat(dname,itoa(pNo,tmp,10));*/
    std::sprintf(tmp, "%d", pNo);
    strcat(dname,tmp);
    fdesc = fopen(dname,"wb");

    fwrite(locsP , sizeof(long long),pS1,fdesc);

    fclose(fdesc);

}



void searchNsave(int pNo)
{
    FILE *fsave,*fdesc;
    long long i = 0 , j = 0 , k = 0;
    double *ts,d , lD = 0 , sD = 0;
    char tmp[5];
    long long p;



    /*char fname[100]= "temp\\p_";*/
    char fname[100]= "temp/p_";
    /*strcat(fname,itoa(pNo,tmp,10));*/
    std::sprintf(tmp, "%d", pNo);
    strcat(fname,tmp);
    fsave = fopen(fname,"wb");

 
    i = 0;
    j = 0;
    k = 0;
    while ( k < pS1 )
    {

        if( j == pS2 || Dist1[iRef][ind1[i]] < Dist2[iRef][ind2[j]] )
        {
            lD = Dist1[iRef][ind1[i]];
            ts = data1[ind1[i]];
            p = ind1[i]+pageBoundaries[pNo-1];
            i++;
        }
        else
        {
            lD = Dist2[iRef][ind2[j]];
            ts = data2[ind2[j]];
            p = ind2[j]+pageBoundaries[pNo];
            j++;
        }
        

        fwrite(ts,sizeof(double),LENGTH,fsave);
        locsP[k] = p;
        
        if( k == 0 )
            sD = lD;

        k++;
    }

    fclose(fsave);

    /*char dname[100] = "temp\\p_desc_";*/
    char dname[100] = "temp/p_desc_";
    /*strcat(dname,itoa(pNo,tmp,10));*/
    std::sprintf(tmp, "%d", pNo);
    strcat(dname,tmp);
    fdesc = fopen(dname,"wb");

    fwrite(locsP , sizeof(long long),pS1,fdesc);

    fclose(fdesc);

    st[pNo] = sD;
    en[pNo] = lD;


    /*strcpy(fname , "temp\\p_");*/
    strcpy(fname , "temp/p_");
    /*strcat(fname,itoa(pNo+1,tmp,10));*/
    std::sprintf(tmp, "%d", pNo+1);
    strcat(fname,tmp);
    fsave = fopen(fname,"wb");


    k = 0;
    while (k < pS2)
    {
        if( i == pS1 )
        {
            lD = Dist2[iRef][ind2[j]];
            ts = data2[ind2[j]];
            p = ind2[j]+pageBoundaries[pNo];
            j++;
        }
        else if( j == pS2 || Dist1[iRef][ind1[i]] < Dist2[iRef][ind2[j]] )
        {
            lD = Dist1[iRef][ind1[i]];
            ts = data1[ind1[i]];
            p = ind1[i]+pageBoundaries[pNo-1];
            i++;
        }
        else
        {
            lD = Dist2[iRef][ind2[j]];
            ts = data2[ind2[j]];
            p = ind2[j]+pageBoundaries[pNo];
            j++;
        }

        fwrite(ts,sizeof(double),LENGTH,fsave);
        locsP[k] = p;

        if( k == 0 )
            sD = lD;

        k++;
    }
    fclose(fsave);


    /*strcpy(dname , "temp\\p_desc_");*/
    strcpy(dname , "temp/p_desc_");
    /*strcat(dname,itoa(pNo+1,tmp,10));*/
    std::sprintf(tmp, "%d", pNo+1);
    strcat(dname,tmp);
    fdesc = fopen(dname,"wb");

    fwrite(locsP , sizeof(long long),pS2,fdesc);
    
    fclose(fdesc);
    
    st[pNo+1] = sD;
    en[pNo+1] = lD;


}



long long load( double **data, double ** Dist , long long * locations , int pNo, int flag)
{

    countLoads ++;

    double d;
    long long i = 0 , j  = 0;
    char tmp[10];

    long long pS = pageBoundaries[pNo]-pageBoundaries[pNo-1];
    FILE *fp;

    /*char dname[100] = "temp\\p_desc_";*/
    char dname[100] = "temp/p_desc_";
    /*strcat(dname,itoa(pNo,tmp,10));*/
    std::sprintf(tmp, "%d", pNo);
    strcat(dname,tmp);
    fp = fopen(dname,"rb");


    for ( i = 0 ; i < pS ; i++ )
    {
        fread(&locations[i],sizeof(long long),1,fp);
    }

    fclose(fp);

    /*char fname[100]= "temp\\p_";*/
    char fname[100]= "temp/p_";
    /*strcat(fname,itoa(pNo,tmp,10));*/
    std::sprintf(tmp, "%d", pNo);
    strcat(fname,tmp);
    fp = fopen(fname,"rb");

    i = 0 ;
  
    while( !feof(fp) && i < maxPageSizeTS)
    {
        fread( data[i],sizeof(double),LENGTH,fp);
        i++;
    }
    
    if(feof(fp))
        i--;
    if( ferror(fp ) )
        error(1);
   if( i != pS )
   {
       printf("i is %lld and pS is %lld  and pNo is %d\n\n",i,pS,pNo);
       error(7);
    }
    fclose(fp);


    ::Dist = Dist;
    ::data = data;
    computeDist(data,  Dist , pS , locations , flag );
 
    return pS;
}




void searchPartitions ( int start , int mid ,  int end )
{
    long long i , j , s , l1 , l2 , iStart = 0 ;
    double d;
    int r , p , p1 , p2 ;
    int runPg = 0 ,  run = 0;
    double t1,t2;
    
    
    
    if( end-start < 1 )
        return;
        

        
        
    for( p1 = start ; p1 < mid ; p1++ )
    {

        if( ( st[mid] - en[p1] ) >= bsf  && (mid-start) > 1 )
            continue;

        t1 = clock();
        pS1 = load(data1,Dist1,locations1,p1,1);
        t2 = clock();
        diskTime += (t2-t1)/CLOCKS_PER_SEC;

        if( mid-start == 1 )
           searchInBlock(data1,Dist1, pS1, locations1);
//            motif(data1,Dist1, pS1, locations1);

        iStart = 0;

        for( p2 = mid ; p2 < end ; p2++ )
        {
            if( (st[p2] - en[p1]) >= bsf && (end-mid) > 1)
                break;

            t1 = clock();
            pS2 = load(data2,Dist2,locations2,p2,1);
            t2 = clock();
            diskTime += (t2-t1)/CLOCKS_PER_SEC;
            
            if( end-mid == 1 )
//                motif(data2,Dist2, pS2, locations2);
                searchInBlock(data2,Dist2, pS2, locations2);            
            
                for( i = iStart ; i < pS1 ; i++ )
                {
                    l1 = locations1[i];

                    for( j = 0 ; j < pS2 ; j++ )
                    {

                        l2 = locations2[j];

                        double lower_bound = 0;
                        lower_bound = fabs(Dist1[iRef][i] - Dist2[iRef][j]);

                        if( lower_bound < bsf )
                        {

                            if ( labs(l1-l2) >= clear )
                            {
                                r = 0;
                                do
                                {
                                    lower_bound = fabs(Dist1[rInd[r]][i] - Dist2[rInd[r]][j]);
                                    r++;
                                }while( r < MAXREF && lower_bound < bsf );


                                if (r >= MAXREF && lower_bound < bsf)
                                {
                                    d = distance( data1[i] , data2[j] , LENGTH , bsf );
                                    if (d < bsf )
                                    {
                                        bsf = d;
                                        loc1 = locations1[i];
                                        loc2 = locations2[j];
                                        memcpy(ts1,data1[i],sizeof(double)*LENGTH);
                                        memcpy(ts2,data2[j],sizeof(double)*LENGTH);
                                    }
                                }
                             }//end if l1 - l2 >= clear
                        }
                        else
                        {
                            iStart = i;
                            break;
                        }
                    }//end for j
                }//end for i
            

        }//end for p2

    }//end for p1


}
    
void mergeNsave(int start, int mid , int end)
{
    FILE *fsave,*fdesc;
    long long i = 0 , j = 0 , k = 0 , PSz;
    double *ts;
    long long p;
    char tmp[10];
    int lind = start,  rind = mid , pind = 0;
    double lD = 0 , sD = 0 , t1 , t2;

    k = 0;

    t1 = clock();
    
    pS1 = load(data1,Dist1,locations1,lind,0);
    pS2 = load(data2,Dist2,locations2,rind,0);

 
    t2 = clock();
    diskTime += (t2-t1)/CLOCKS_PER_SEC;


    lind++;
    rind++;

    while(1)
    {

        /*char fname[100]= "temp\\p_";*/
        char fname[100]= "temp/p_";
        /*strcat(fname,itoa(end-start,tmp,10));*/
        std::sprintf(tmp, "%d", end-start);
        strcat(fname,tmp);
        strcat(fname,"_");
        /*strcat(fname,itoa(start+pind,tmp,10));*/
        std::sprintf(tmp, "%d", start+pind);
        strcat(fname,tmp);
        fsave = fopen(fname,"wb");



        k = 0;
        PSz = ( pageBoundaries[start+pind]- pageBoundaries[start+pind-1]);
        
        while( k < PSz )
        {
            if ( i == pS1 && lind < mid )
            {
                t1 = clock(); 
                pS1 = load(data1,Dist1,locations1,lind , 0);
                t2 = clock();
 
                lind++;
                i = 0;
            }
            if( j == pS2 && rind < end )
            {
                t1 = clock();
                pS2 = load(data2,Dist2,locations2,rind , 0);
                t2 = clock();
                diskTime += (t2-t1)/CLOCKS_PER_SEC;
                rind++;
                j = 0;
            }

            if( i == pS1 && j == pS2 && lind == mid && rind == end )
                break;

            if( i == pS1 && lind == mid && j < pS2)
            {
                lD = Dist2[iRef][j];
                ts = data2[j];
                p = locations2[j];
                j++;
            }
            else if( j == pS2 && rind == end  && i < pS1)
            {
                lD = Dist1[iRef][i];
                ts = data1[i];
                p = locations1[i];
                i++;
            }

            else if( Dist1[iRef][i] < Dist2[iRef][j] )
            {
                lD = Dist1[iRef][i];
                ts = data1[i];
                p = locations1[i];
                i++;
            }
            else
            {
                lD = Dist2[iRef][j];
                ts = data2[j];
                p = locations2[j];
                j++;
            }


            fwrite(ts,sizeof(double),LENGTH,fsave);

            locsP[k] = p;
            
            if( k == 0 )
                sD = lD;
     

            k++;
        }
        
        fclose(fsave);

        /*char dname[100] = "temp\\p_desc_";*/
        char dname[100] = "temp/p_desc_";
        /*strcat(dname,itoa(end-start,tmp,10));*/
        std::sprintf(tmp, "%d", end-start);
        strcat(dname,tmp);
        strcat(dname,"_");
        /*strcat(dname,itoa(start+pind,tmp,10));*/
        std::sprintf(tmp, "%d", start+pind);
        strcat(dname,tmp);
        fdesc = fopen(dname,"wb");

            fwrite(locsP,sizeof(long long),PSz,fdesc);

        fclose(fdesc);

        st[start+pind] = sD;
        en[start+pind] = lD;

        pind ++ ;


        if( i == pS1 && j == pS2 && lind == mid && rind == end )
            break;

    }

    if( pind !=  ( end-start ) )
     {
            printf("%ld %ld\n\n",pind,end-start);
            error(7);
     }



    for ( k = 0  ; k < pind ; k++ )
    {
        /*char dname[100] = "temp\\p_desc_";*/
        char dname[100] = "temp/p_desc_";
        /*strcat(dname,itoa(start+k,tmp,10));*/
        std::sprintf(tmp, "%d", start+k);
        strcat(dname,tmp);
        remove(dname);

        /*char fname[100]= "temp\\p_";*/
        char fname[100]= "temp/p_";
        /*strcat(fname,itoa(start+k,tmp,10));*/
        std::sprintf(tmp, "%d", start+k);
        strcat(fname,tmp);
        remove(fname);

        /*char d2name[100] = "temp\\p_desc_";*/
        char d2name[100] = "temp/p_desc_";
        /*strcat(d2name,itoa(end-start,tmp,10));*/
        std::sprintf(tmp, "%d", end-start);
        strcat(d2name,tmp);
        strcat(d2name,"_");
        /*strcat(d2name,itoa(start+k,tmp,10));*/
        std::sprintf(tmp, "%d", start+k);
        strcat(d2name,tmp);
        rename(d2name  ,  dname);

        /*char f2name[100]= "temp\\p_";*/
        char f2name[100]= "temp/p_";
        /*strcat(f2name,itoa(end-start,tmp,10));*/
        std::sprintf(tmp, "%d", end-start);
        strcat(f2name,tmp);
        strcat(f2name,"_");
        /*strcat(f2name,itoa(start+k,tmp,10));*/
        std::sprintf(tmp, "%d", start+k);
        strcat(f2name,tmp);
        rename(f2name  ,  fname);
    }
}



int main(int argc , char * argv[])
{

    double d;
    long long i , j ;
    int  r = 0 , p = 0;
    double ex , ex2 , mean, std;

    double t1,t2,t11,t22,tt1,tt2;
    char fname[100] , tmp[5];
    long long length;
    double tExecTime, tDiskTime;    
    long long cumLoads = 0;
    long long cumDists = 0;

    

    bsf = INF;
    i = 0;
    j = 0;
    ex = ex2 = 0;

    t11 = clock();


    LENGTH = atoi(argv[3]);
    MAXREF = 8 ;
    maxPageSizeTS = atol(argv[4]);;
    length = atol(argv[2]);;
    clear = LENGTH;
  
    printf("*********************   ALLOCATING MEMEORY   ********************** \n\n");
    
    dref = (double **)malloc(MAXREF*sizeof(double *));
    stdRef = (double *)malloc(MAXREF*sizeof(double));
    rInd = (int *)malloc(MAXREF*sizeof(int));
    refs = (long long *)malloc(MAXREF*sizeof(long long));

    if ( dref == NULL  || stdRef == NULL  || rInd == NULL  || refs == NULL)
        error(1);
    
    
    
    data1 = (double **)malloc( sizeof(double *)*maxPageSizeTS);
    ind1 = (long long *)malloc( sizeof(long long)*maxPageSizeTS);
    data2 = (double **)malloc( sizeof(double *)*maxPageSizeTS);
    ind2 = (long long *)malloc( sizeof(long long)*maxPageSizeTS);


    if( data1 == NULL || ind1 == NULL ||  data2 == NULL || ind2 == NULL )
        error(1);
    
    
    for ( i = 0 ; i < maxPageSizeTS ; i++ )
    {
        data1[i] = (double *)malloc(sizeof(double)*LENGTH);
        data2[i] = (double *)malloc(sizeof(double)*LENGTH);
        if( data1[i] ==  NULL || data2[i] == NULL )
            error(1);
    }
    
    
    Dist1 = (double **)malloc(MAXREF*sizeof(double *));
    Dist2 = (double **)malloc(MAXREF*sizeof(double *));
    if( Dist1 == NULL || Dist2 == NULL )
        error(1);

    for( r = 0 ; r < MAXREF ; r++ )
    {
        Dist1[r] = (double *)malloc(sizeof(double)*maxPageSizeTS);
        Dist2[r] = (double *)malloc(sizeof(double)*maxPageSizeTS);
        if( Dist1[r] == NULL || Dist2[r] == NULL )
            error(1);

    }
    
 
    locations1 = (long long * )malloc(sizeof(long long)*maxPageSizeTS);
    locations2 = (long long * )malloc(sizeof(long long)*maxPageSizeTS);
    locsP = (long long *)malloc(sizeof(long long)*maxPageSizeTS);

    if( locsP == NULL || locations1 == NULL || locations2 == NULL )
        error(1);


    numOfPages = (long long)ceil((length-LENGTH+1)/(double)maxPageSizeTS);
    
    pageBoundaries = (long long *)malloc(sizeof(long long)*numOfPages*2);
    pageBoundaries[0]=0;


    st = (double *)malloc(sizeof(double)*numOfPages+1);
    en = (double *)malloc(sizeof(double)*numOfPages+1);
    if( st == NULL || en == NULL )
        error(1);
        
    ts1 = (double *)malloc(sizeof(double)*LENGTH);
    ts2 = (double *)malloc(sizeof(double)*LENGTH);    


    strcpy(fname,argv[1]);
    flong = fopen( fname , "r" );
    
    overlap = LENGTH - 1;
        
    buffer = (double *)malloc(sizeof(double)*overlap);
        
    for( i = 0 ; i < overlap ; i++ )
        fscanf(flong,"%lf",&buffer[i]);
    

    pS1 = subLoad(data1,ind1);
    pageBoundaries[1] = pS1;
    for( i = 0 ; i < pS1 ; i++ )
        locations1[i] = i + pageBoundaries[0];
        


    ////////////////////   REFERENCE GENERATION BLOCK       ///////////////////

    printf("*********************   GENERATING REFERENCES   ********************** \n\n");


    srand ( time(NULL) );
    /*FILE * fref = fopen("temp\\ref.txt","w");*/
    FILE * fref = fopen("temp/ref.txt","w");
    for( r = 0 ; r < MAXREF ; r++ )
    {

        dref[r] = (double *)malloc(sizeof(double)*LENGTH);
        if( dref[r] == NULL )
            error(1);

       long long random_pick = rand() % pS1;        //for the time being
            refs[r] = random_pick;
      //  refs[r] = r*20+19;
        for( i = 0 ; i < LENGTH ; i++ )
        {
            dref[r][i] = data1[refs[r]][i];
            fprintf(fref,"%lf ",dref[r][i]);
        }
        fprintf(fref,"\n");

    }
    fclose(fref);
    

    iRef = 0;

    printf("*********************  SORTING : FIRST PASS    ********************** \n\n");

    t1 = clock();
    diskTime = 0;
    
    p = 1;
    while (p <= numOfPages)
    {

        if( p != 1 )
        {
            if( p == numOfPages )
                tt1 = clock();
            tt1 = clock();
            pS1 = subLoad(data1,ind1);
            tt2 = clock();
            diskTime += (tt2-tt1)/CLOCKS_PER_SEC;
 
            pageBoundaries[p] = pageBoundaries[p-1] + pS1;
            for( i = 0 ; i < pS1 ; i++ )
                locations1[i] = i + pageBoundaries[p-1];

        }

        sortdata(data1,ind1,Dist1,pS1,locations1);

        
        if( p+1 > numOfPages )
        {

            takeNsave(p);
            printf("In Pass 1: After %d pages : %lf %lld %lld \n",p,bsf,loc1,loc2);
            break;
        }

        tt1 = clock();
        pS2 = subLoad(data2,ind2);
        tt2 = clock();
        diskTime += (tt2-tt1)/CLOCKS_PER_SEC;
        
        
        pageBoundaries[p+1] = pageBoundaries[p] + pS2;
        for( i = 0 ; i < pS2 ; i++ )
            locations2[i] = i + pageBoundaries[p];
   
        sortdata(data2,ind2,Dist2, pS2, locations2);


        printf("In Pass 1: After %d pages : %lf %lld %lld \n",p+1,bsf,loc1,loc2);

        searchNsave(p);
        p+=2;
    }

    printf("Number of Page Loads : %d\n",countLoads);
    printf("Number of Distance Computations : %lld\n",countDists);
    cumLoads += countLoads;
    cumDists += countDists;
    countLoads = 0;
    countDists = 0;
 
    t2 = clock();
    printf("Time taken in the Pass 1 is %lf\n\n",(t2-t1)/CLOCKS_PER_SEC);
    printf("Time taken in disk loading %lf\n\n\n",diskTime);    
   

    printf("*********************   SORTING : MERGING PHASE    ********************** \n\n");


    int m = 2;
    int of;
    int end;
    int mid;
    int stop = 0;

    tExecTime = 0;
    tDiskTime = 0;

    while( m < numOfPages && !stop )
    {
        t1 = clock();
        p = 1;
        diskTime = 0;        
        
        while( p <= numOfPages )
        {
            if( p+m > numOfPages )
                mid = numOfPages+1;
            else
                mid = p+m;

            if( p+2*m > numOfPages )
                end = numOfPages+1;
            else
                end = p+2*m;
                
            if( mid == end )
                break;

            printf("Merging %d , %d and %d , %d \n",p,mid-1,mid,end-1);
            mergeNsave(p,mid,end);
            p = p+2*m;
        }

        printf("In %d Pass : %lf %lld %lld \n",m,bsf,loc1,loc2);
        printf("Number of Page Loads : %d\n",countLoads);
        printf("Number of Distance Computations : %lld\n",countDists);
        cumLoads += countLoads;
        cumDists += countDists;
        countLoads = 0;
        countDists = 0;
 
        t2 = clock();
        printf("Time taken in the Pass %d is %lf\n\n",m,(t2-t1)/CLOCKS_PER_SEC);
        printf("Time taken in disk loading %lf\n\n\n",diskTime);
        tDiskTime += diskTime;
        tExecTime += (t2-t1)/CLOCKS_PER_SEC;

        m = 2*m;
    }


    printf("Time taken in the merging phase is %lf\n\n",tExecTime);
    printf("Time taken in disk loading while Merging is %lf\n\n\n",tDiskTime);


    printf("*********************   SEARCHING PHASE    ********************** \n\n");
    
    m = 1;
    stop = 0;
   
    tExecTime = 0;
    tDiskTime = 0;
            
    while( m < numOfPages && !stop )
    {
 
        t1 = clock();
        diskTime = 0;


        p = 1;

        while( p <= numOfPages )
        {
            if( p+m > numOfPages )
                mid = numOfPages+1;
            else
                mid = p+m;

            if( p+2*m > numOfPages )
                end = numOfPages+1;
            else
                end = p+2*m;

            if( mid == end )
                break;

            printf("Searching %d , %d and %d , %d \n",p,mid-1,mid,end-1);

            searchPartitions(p,mid,end);


            p = p+2*m;
        }

        printf("\n\n\nIn %d Pass : %lf %lld %lld \n",m,bsf,loc1,loc2);
        printf("Number of Page Loads : %d\n",countLoads);
        printf("Number of Distance Computations : %lld\n",countDists);

        t2 = clock();
        printf("Time taken in the Pass %d is %lf\n\n",m,(t2-t1)/CLOCKS_PER_SEC);
        printf("Time taken in disk loading %lf\n\n\n",diskTime);


        tDiskTime += diskTime;
        tExecTime += (t2-t1)/CLOCKS_PER_SEC;


        cumLoads += countLoads;
        cumDists += countDists;
        countLoads = 0;
        countDists = 0;
        m = 2*m;
    }

    printf("Time taken in searching is %lf\n\n",tExecTime);
    printf("Time taken in disk loading while searching is %lf\n\n\n",tDiskTime);

    printf("\n\n\n********************   FINISHED SEARCHING    ********************** \n\n");



    printf("Motif Distance : %lf\nLocation 1 : %lld\nLocation 2 : %lld\n\n",bsf,loc1,loc2);
     
    printf("Total Page Loads %lld\n",cumLoads);
    printf("Total Distance Computations %lld\n",cumDists);

    t22 = clock();
    printf("Execution time was %lf\n\n%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\n\n",(t22-t11)/CLOCKS_PER_SEC);
    
//    searchEnvelop();


    //system("read -n 1 -p \"Press any key to continue\"");


}
